#include <stdio.h>

#define MAXDATA 1024
#define MAXCHAR 1024

main(int argc,char *argv[])
{
  int i,j;
  int ii;
  int imax1,imax2;
  int iimax;
  int jmin[MAXDATA];
  double x1[MAXDATA],y1[MAXDATA],x2[MAXDATA],y2[MAXDATA];
  double fx1[MAXDATA],fy1[MAXDATA],fx2[MAXDATA],fy2[MAXDATA];
  double d,dmin;
  double dx,dy;
  FILE *fp;
  char line[MAXCHAR];
  double searchmax;

  if(argc != 4){
    fprintf(stderr,"Usage: matchpat file1 file2 max_radius\n");
    exit(0);
  }
  
  searchmax=20.0;
  sscanf(argv[3],"%lf",&searchmax);
  /*  fprintf(stderr,"%lf\n",searchmax); */

  /* Load Data */
  if((fp = fopen(argv[1],"r")) == NULL){
    fprintf(stderr,"Cannot open %s\n",argv[1]);
    exit(1);
  }
  i=0;
  while(fgets(line,MAXCHAR,fp)!=NULL){
    sscanf(line,"%lf %lf",&x1[i],&y1[i]);
    i++;
  }
  imax1=i;
  fclose(fp);
  
  if((fp = fopen(argv[2],"r")) == NULL){ 
    fprintf(stderr,"Cannot open %s\n",argv[2]);
    exit(1);
  }
  i=0;
  while(fgets(line,MAXCHAR,fp)!=NULL){
    sscanf(line,"%lf %lf",&(x2[i]),&(y2[i]));
    i++;
  }
  imax2=i;
  fclose(fp);
  
  /* Pattern Matching */

  ii=0;  
  for(i=0;i<imax1;i++){
    /*    fprintf(stderr,"%d,%lf,%lf\n",i,x1[i],y1[i]); */
    dmin=4*searchmax*searchmax;
    for(j=0;j<imax2;j++){
      d=(x1[i]-x2[j])*(x1[i]-x2[j])+(y1[i]-y2[j])*(y1[i]-y2[j]);
      if(d<dmin){
	dmin=d;
	jmin[i]=j;
      }
    }
    if(dmin < searchmax*searchmax){
      fx1[ii]=x1[i];fy1[ii]=y1[i];
      fx2[ii]=x2[jmin[i]];fy2[ii]=y2[jmin[i]];
      ii++;
    }
  }
  iimax=ii;

  /* Calculate Minimum dx,dy*/
  dx=0;dy=0;
  for(i=0;i<iimax;i++){
    /*    fprintf(stderr,"%lf,%lf\t%lf,%lf\n",fx1[i],fy1[i],fx2[i],fy2[i]); */
    dx+=(fx1[i]-fx2[i])/((double) iimax);
    dy+=(fy1[i]-fy2[i])/((double) iimax);
  }

  fprintf(stdout,"%lf\t%lf\n",dx,dy);
  fprintf(stderr,"  Offset: x=%lf\ty=%lf\n",dx,dy);
}
